#include<iostream>
#include<algorithm>
#include<assert.h>
#include<string>
#include<vector>
#include<tuple>
#define MAXN 1000
#define MAXK 100000
#define OFFSET MAXK+MAXN+1
using namespace std;
pair <int, int> diff[]={{-1, 0}, {1, 0}, {0, 1}, {0, -1}};
pair <int, int> operator+ (const pair <int, int>& l, const pair <int, int>& r) {
    return {l.first+r.first, l.second+r.second};
}
pair <int, int> operator- (const pair <int, int>& l, const pair <int, int>& r) {
    return {l.first-r.first, l.second-r.second};
}
int stop[MAXK+1];
int indX[2*MAXK+MAXN+1],indY[2*MAXK+MAXN+1];
int main () {
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);
    int n;
    assert(cin >> n );
    assert((n>=1)&&(n<=MAXN));
    pair <int, int> st={-1, -1};
    vector <pair <int, int> > bad;
    for (int i=0; i<n; i++) {
        string row;
        assert(cin >> row );
        for (int j=0; j<n; j++) {
            if (row[j]=='S') assert(st.first==-1), st={i+1, j+1};
            else if (row[j]=='X') bad.push_back({i+1, j+1});
            else assert(row[j]=='.');
        }
    }
    assert(st.first!=-1);
    assert(bad.size()<=300);
    string s;
    assert(cin >> s );
    char temp; assert(!(cin >> temp));
    int k=s.size();
    assert((k>=1)&&(k<=MAXK));
    pair <int, int> curr=st;
    vector <tuple <int, int, int> > diffs(k);
    vector <tuple <int, int, int> > pref(k);
    for (int i=0; i<k; i++) {
        if (s[i]=='U') s[i]=0;
        else if (s[i]=='D') s[i]=1;
        else if (s[i]=='R') s[i]=2;
        else s[i]=3;
        auto d=curr-st;
        diffs[i]={d.first, d.second, i+1};
        curr=curr+diff[s[i]];
        pref[i]={curr.first, curr.second, i+1};
        stop[i+1]=k+1;
    }
    sort(diffs.begin(),diffs.end());
    sort(pref.begin(),pref.end());
    sort(bad.begin(),bad.end());
    for (auto b : bad) {
        int l=0;
        for (int r=0; r<k; r++) {
            auto [x, y, indr]=pref[r];
            auto d=make_pair(x,y)-b;
            //cout << d.first << " " << d.second << " " << indr << endl ;
            for (;;) {
                if (l==k) break;
                auto [x, y, indl]=diffs[l];
                if ((x>d.first)||((x==d.first)&&(y>d.second))||
                    ((x==d.first)&&(y==d.second)&&(indl>indr))) break;
                if ((x==d.first)&&(y==d.second)&&(indl<=indr)) stop[indl]=min(stop[indl],indr);
                l++;
            }
            if (l==k) break;
        }
        //cout << endl ;
    }
    curr={get<0>(pref[k-1]), get<1>(pref[k-1])};
    for (int i=k; i>=1; i--) {
        indX[curr.first-0+OFFSET]=i; indX[curr.first-(n+1)+OFFSET]=i;
        indY[curr.second-0+OFFSET]=i; indY[curr.second-(n+1)+OFFSET]=i;
        curr=curr-diff[s[i-1]];
        pair <int, int> d=curr-st;
        if (indX[d.first+OFFSET]!=0) stop[i]=min(stop[i],indX[d.first+OFFSET]);
        if (indY[d.second+OFFSET]!=0) stop[i]=min(stop[i],indY[d.second+OFFSET]);
    }
    long long int ans=0;
    for (int i=1; i<=k; i++) {
        //cout << i << " " << stop[i] << endl ;
        ans+=(stop[i]-i);
    }
    cout << ans ;
    cout << endl ;
    return 0;
}
